"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createEjsRenameTransform = void 0;
const through2_1 = __importDefault(require("through2"));
/**
 * Transform stream for remove .ejs extension from files. We are using this extension to improve code
 * highlight in editor
 */
function createEjsRenameTransform() {
    return through2_1.default.obj(function (file, _enc, callback) {
        Promise.resolve()
            .then(() => {
            file.basename = file.basename
                .replace(/.ts.ejs$/, '.ts')
                .replace(/.tsx.ejs$/, '.tsx');
            this.push(file);
            return callback();
        });
    });
}
exports.createEjsRenameTransform = createEjsRenameTransform;
//# sourceMappingURL=createEjsRenameTransform.js.map