"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.addScreenToAdminUi = void 0;
const j = __importStar(require("jscodeshift"));
const recordRepresentationFunctionName_1 = require("../../../../../generators/react-admin/common/recordRepresentation/recordRepresentationFunctionName");
const insertSpecifierImport_1 = require("../jsCodeShift/insertSpecifierImport");
const parseTs_1 = require("../../../../util/parseTs");
const recordRepresentationFunctionImport_1 = require("../../../../../generators/react-admin/common/recordRepresentation/recordRepresentationFunctionImport");
const getAdminUiTagChildren_1 = require("./getAdminUiTagChildren");
const composeImportForAppTsx_1 = require("./composeImportForAppTsx");
function addScreenToAdminUi(appTsxInput, resourceName, screenName, screenType, screenImportPath) {
    // custom TS parser required
    const appAST = (0, parseTs_1.parseTs)(appTsxInput);
    const adminUi = appAST.findJSXElements("AdminUI");
    const children = (0, getAdminUiTagChildren_1.getAdminUiTagChildren)(adminUi);
    // try to find already existed <ResourceSecured name={resourceName}> tag in AdminUI
    const resourceItem = children
        .filter(el => el.type === j.JSXElement.toString())
        .find(el => {
        const openingEl = el.openingElement;
        return openingEl?.name?.name === "ResourceSecured" &&
            openingEl?.attributes?.some((attr) => attr.name?.name === "name" && attr.value?.value === resourceName);
    });
    if (resourceItem != null) {
        console.log(`addScreenToAdminUi: skip adding resource item to AdminUI tag, item ${resourceName} already exist`);
        const openingEl = resourceItem.openingElement;
        // try to find attribute, named as screenType in Resource tag
        const screenAttr = openingEl?.attributes?.find((attr) => attr.name.name === screenType);
        if (screenAttr != null) {
            // screen with such type already exist in Resource - overwrite attr value
            screenAttr.value = j.jsxExpressionContainer(j.jsxIdentifier(screenName));
            console.log(`addScreenToAdminUi: update attribute value to ${screenType}={ ${screenName} }'` +
                ` in ${resourceName} resource tag`);
        }
        else {
            // attribute for such screen type doesn't exist in Resource tag
            // add attribute `screenType={screenName}` to Resource tag
            // result example `<ResourceSecured create={ PetCreateAdvanced } />`
            const newScreenAttr = j.jsxAttribute(j.jsxIdentifier(screenType), j.jsxExpressionContainer(j.jsxIdentifier(screenName)));
            openingEl.attributes.push(newScreenAttr);
            console.log(`addScreenToAdminUi: attribute '${screenType}={ ${screenName} }' ` +
                `added to ${resourceName} resource tag`);
        }
    }
    else {
        const resourceItemTag = createResourceTag(resourceName, screenType, screenName);
        children?.push(j.stringLiteral(resourceItemTag));
        console.log(`addScreenToAdminUi: adding item to AdminUI tag \n${resourceItemTag} `);
    }
    (0, insertSpecifierImport_1.insertSpecifierImport)(appAST, "ResourceSecured", "../core/security/components/ResourceSecured");
    const importPath = (0, composeImportForAppTsx_1.composeImportForAppTsx)(screenImportPath, screenName);
    (0, insertSpecifierImport_1.insertSpecifierImport)(appAST, screenName, importPath);
    const recordRepFunctionName = (0, recordRepresentationFunctionName_1.recordRepresentationFunctionName)(resourceName);
    // for App.tsx import path always starts from `../core/record-representation/`
    const recordRepFunctionImport = (0, recordRepresentationFunctionImport_1.recordRepresentationFunctionImport)("..", resourceName);
    (0, insertSpecifierImport_1.insertSpecifierImport)(appAST, recordRepFunctionName, recordRepFunctionImport);
    return appAST.toSource();
}
exports.addScreenToAdminUi = addScreenToAdminUi;
function createResourceTag(resourceName, screenType, screenName) {
    return `` +
        `<ResourceSecured name="${resourceName}"` +
        ` ${screenType}={${screenName}} recordRepresentation={${(0, recordRepresentationFunctionName_1.recordRepresentationFunctionName)(resourceName)}} />`;
}
//# sourceMappingURL=addScreenToAdminUi.js.map