"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeScreenToAdminUi = void 0;
const addScreenToAdminUi_1 = require("../../../building-blocks/stages/writing/pieces/screen/addScreenToAdminUi");
function writeScreenToAdminUi(gen, screenPaths, entityName, screenName, screenType) {
    const appTsxFilePath = screenPaths.appTsxPath;
    // const screenImportPath: string = composeScreenImportPath(screenPaths.relativeDestPath);
    if (!gen.fs.exists(appTsxFilePath)) {
        gen.log(`Unable to add screen to AdminUI, App.tsx file not found in path '${appTsxFilePath}'`);
    }
    else {
        const appContents = gen.fs.read(appTsxFilePath);
        const appTransformed = (0, addScreenToAdminUi_1.addScreenToAdminUi)(appContents, entityName, screenName, screenType, screenPaths.relativeDestPath);
        gen.fs.write(appTsxFilePath, appTransformed);
        gen.log(`Screen '${screenType}:${screenName}' added to AdminUI tag in '${appTsxFilePath}'`);
    }
}
exports.writeScreenToAdminUi = writeScreenToAdminUi;
//# sourceMappingURL=writeScreenToAdminUi.js.map